clc
clear
close all
set_parameters
Gq=256*10^-6;
u=60/3.6;
gain_noise=2*pi*n0*sqrt(Gq*u);
T=(l1+l2)/u;
global flag_penalty
flag_penalty=1;  %不使用罚函数
%% 定义遗传算法参数
nind = 60;      %种群大小
maxgen = 100;     %最大遗传迭代次数
NVAR= 3;
preci = 36;     %个体长度
ggap = 0.95;    %代沟
px = 0.7;       %交叉概率
pm = 0.01;      %变异概率
trace = zeros(NVAR+1, maxgen);               %寻优结果初始化
FieldDR=[0,0,0;   %寻优范围 最小值 
    2^12-1,2^12-1,2^6-1]; % 寻优范围 最大值
%%
global passive_scores
Kp=0;
Ki=0;
Kd=0;
lambda0=1;
mu0=1;
out=sim("model_8.slx");
mdlWks = get_param('model_8','ModelWorkspace');
assignin(mdlWks,'Kp',Kp);
assignin(mdlWks,'Ki',Ki);
assignin(mdlWks,'Kd',Kd);
assignin(mdlWks,'lambda0',lambda0);
assignin(mdlWks,'mu0',mu0);
passive_scores=zeros(12,1);
out=sim("model_8.slx");
z=out.z;
ddz=out.ddz;
zr=out.zr;
zc=z(:,1);
zb=z(:,2);
theta=z(:,3);
phi=z(:,4);
zu=z(:,5:8);
zs(:,1)=zb-l1*theta+l3*phi;
zs(:,2)=zb-l1*theta-l4*phi;
zs(:,3)=zb+l2*theta+l3*phi;
zs(:,4)=zb+l2*theta-l4*phi;
zxy=zb-rx*theta+ry*phi;
passive_scores(1:4)=sqrt(mean(ddz(:,1:4).^2,1));
passive_scores(5:8)=sqrt(mean((zs-zu).^2,1));
passive_scores(9:12)=sqrt(mean((zu-zr).^2,1));
%% 遗传算法
% fieldd = [preci preci;kp_range;ki_range;kd_range;1 1;0 0;1 1;1 1]; %区域描述器
fieldd = [rep([preci],[1, NVAR]);...
              FieldDR;...
              rep([1; 0; 1 ;1], [1, NVAR])];
chrom = crtbp(nind, preci * NVAR);         %种群初始化（任意离散随机种群）
chrom(1,:)=zeros(1,preci * NVAR);
% 优化
gen = 0;                                                %代计数器
XY = bs2rv(chrom, fieldd);                              %初始种群二进制转十进制
X = XY(:, 1); Y = XY(:, 2);
for i=1:nind
    objv(i,1) = fitness_PID(XY(i,:));
end %计算目标函数值

while gen < maxgen
    disp(['第',num2str(gen),'代']);
    fitnv = ranking(objv);                             %分配适应度值
    selch = select('sus', chrom, fitnv, ggap);          %选择
    selch = recombin('xovsp', selch, px);               %交叉
    selch = mut(selch, pm);                             %变异
    XY = bs2rv(selch, fieldd);                          %子代个体十进制转换
    objvsel=[];
    for i=1:size(XY,1)
        objvsel(i,1) = fitness_PID(XY(i,:));
    end%计算目标函数值
    [chrom, objv] = reins(chrom, selch, 1, 1, objv, objvsel);   %重插入子代到父代，得到新种群
    XY = bs2rv(chrom, fieldd);
    gen = gen + 1;
    %获取每代的最优解及其序号，Y为最优解，i为个体的序号
    [Y, i] = min(objv);
    trace(1:NVAR, gen) = XY(i, :);
    trace(NVAR+1, gen) = Y;
end

%% 画进化图
%trace 中的变量分别是：Kp ki kd lambda mu 适应值
figure
plot(1 : maxgen, trace(NVAR+1, :));
grid on;
xlabel('遗传代数')
ylabel('解的变化')
title('进化过程')

best_k=trace(1:NVAR,end);
disp('最佳参数KP KI KD')
disp(best_k)
%考察是否满足约束
% best_k=x;
[c,~]=nonlconstraint([best_k;1;1]);
index=find(c>=1);
if(length(index)==0)
    disp('满足约束')
else
    disp('不满足约束的指标位置:')
    disp(index)
end


